/* wrap_pwd.c: Copyright (C) TOYODA Eizi, 1997 */
/* In the public domain. */

#include <stdio.h>
#include <sys/types.h>
#include <pwd.h>
#include <shadow.h>

#define _WRAP_PWD_NO_MACROS
#include "wrap_pwd.h"

static struct passwd  pw;

      struct passwd *
wrap_getpwnam(const char *name)
{
      struct passwd   *xpw;
      struct spwd     *shadow;
      pw = *(xpw = getpwnam(name));
      if ((shadow = getspnam(name)) != NULL) {
              pw.pw_passwd = shadow->sp_pwdp;
      }
      return &pw;
}

      struct passwd *
wrap_getpwuid(uid_t uid)
{
      struct passwd   *xpw;
      struct spwd     *shadow;
      pw = *(xpw = getpwuid(uid));
      if ((shadow = getspnam(pw.pw_name)) != NULL) {
              pw.pw_passwd = shadow->sp_pwdp;
      }
      return &pw;
}
